import 'package:dartz/dartz.dart';
import 'package:fhir/primitive_types/primitive_types.dart';
import 'package:fhir_auth/fhir_auth.dart';
import 'package:flutter/services.dart';
import 'package:google_sign_in/google_sign_in.dart';

class GcsClient extends GoogleSignIn {
  GcsClient({this.baseUrl, String clientId, List<String> scopes})
      : super(clientId: clientId, scopes: scopes);

  final FhirUri baseUrl;

  Future<Either<AuthFailure, Unit>> access() async {
    try {
      print('trying authorization');
      await super.signIn();
    } on PlatformException catch (e) {
      return left(AuthFailure.gcsException(exceptionString: e?.toString()));
    } catch (e) {
      return left(AuthFailure.gcsError(errorString: e?.toString()));
    }

    return right(unit);
  }
}
